#include<bits/stdc++.h>
using namespace std;
long long N,A[200009],B[200009],C[200009],Q,l,r,sol1,sol2,sol3;
int main(){
	cin>>N;
	for(int i=1; i<=N; i++)cin>>A[i];
	for(int i=1; i<=N; i++)if(A[i]>A[i+1] and i+1<=N)B[i]+=1;
	for(int i=1; i<=N; i++)B[i]+=B[i-1];
	bool case2=true;
	for(int i=1; i<=N; i++)if(A[i]!=1 and A[i]!=2)case2=false;
	if(case2){
		int br=0;
		for(int i=1; i<=N; i++){
			if(A[i]==2)br++;
			if(A[i]==1)C[i]=br;
		}
		for(int i=1; i<=N; i++)C[i]+=C[i-1];
		cin>>Q;
		for(int q=1; q<=Q; q++){
			cin>>l>>r;
			sol1=C[r]-C[l];
			if(sol1>1)cout<<"NE"<<endl;
			else cout<<"DA"<<endl;
		}
	}
	else{
		cin>>Q;
		for(int q=1; q<=Q; q++){
			cin>>l>>r;
			sol1=B[r-1]-B[l-1];
			if(sol1>1)cout<<"NE"<<endl;
			else cout<<"DA"<<endl;
		}
	}
	return 0;
}